part of YIM;

class _YIMUserManager {
  _YIMUserManager._internal();

  static final _ = _YIMUserManager._internal();

  factory _YIMUserManager() {
    if (_YIMSDK.option == null) _YIMSDK.utils.yimLog("${_.runtimeType}:Please init First!");
    return _;
  }

  void login({required String user, required String token, void Function(_YIMResult<YIMEnum_LoginResult> result)? callback}) {
    _YIMSDK.server.init(user, token, callback);
  }

  void logout() {
    _YIMSDK.db.dispose();
    _YIMSDK.server.dispose(false);
    _YIMSDK.currentUser = null;
  }

  bool isLogin() => _YIMSDK.currentUser != null && (_YIMSDK.server.socket?.connected ?? false);

  void queryInfo({required String user, required void Function(bool isSuccess, _YIMUser? user) callback}) {
    if (!YIM.userManager.isLogin()) {
      try {
        callback.call(false, null);
      } catch (e) {}
      return;
    }
    _YIMSDK.server.emit("queryUserInfo", data: {
      "accid": user,
    }, ack: (isSuccess, results, code, msg) {
      if (!isSuccess) {
        try {
          callback.call(false, null);
        } catch (e) {}
        return;
      }
      try {
        callback.call(true, _YIMUser.fromJson(results!["user"]));
      } catch (e) {}
    });
  }
}
